import { createRequire } from "module";
import c from "./constants.js";

const require = createRequire(import.meta.url);
export const sweph = require("./build/Release/sweph.node");

sweph.constants = c;
sweph.sweph = sweph;
sweph.default = sweph;

export default sweph;
export const constants = sweph.constants;
export const close = sweph.close;
export const set_delta_t_userdef = sweph.set_delta_t_userdef;
export const set_ephe_path = sweph.set_ephe_path;
export const set_jpl_file = sweph.set_jpl_file;
export const set_sid_mode = sweph.set_sid_mode;
export const set_tid_acc = sweph.set_tid_acc;
export const set_topo = sweph.set_topo;
export const version = sweph.version;
export const get_library_path = sweph.get_library_path;
export const get_tid_acc = sweph.get_tid_acc;
export const get_planet_name = sweph.get_planet_name;
export const get_current_file_data = sweph.get_current_file_data;
export const get_orbital_elements = sweph.get_orbital_elements;
export const get_ayanamsa_name = sweph.get_ayanamsa_name;
export const get_ayanamsa_ex_ut = sweph.get_ayanamsa_ex_ut;
export const get_ayanamsa_ex = sweph.get_ayanamsa_ex;
export const get_ayanamsa_ut = sweph.get_ayanamsa_ut;
export const get_ayanamsa = sweph.get_ayanamsa;
export const calc = sweph.calc;
export const calc_ut = sweph.calc_ut;
export const calc_pctr = sweph.calc_pctr;
export const fixstar = sweph.fixstar;
export const fixstar_ut = sweph.fixstar_ut;
export const fixstar_mag = sweph.fixstar_mag;
export const fixstar2 = sweph.fixstar2;
export const fixstar2_ut = sweph.fixstar2_ut;
export const fixstar2_mag = sweph.fixstar2_mag;
export const nod_aps = sweph.nod_aps;
export const nod_aps_ut = sweph.nod_aps_ut;
export const orbit_max_min_true_distance = sweph.orbit_max_min_true_distance;
export const sol_eclipse_when_loc = sweph.sol_eclipse_when_loc;
export const sol_eclipse_when_glob = sweph.sol_eclipse_when_glob;
export const sol_eclipse_how = sweph.sol_eclipse_how;
export const sol_eclipse_where = sweph.sol_eclipse_where;
export const lun_occult_when_loc = sweph.lun_occult_when_loc;
export const lun_occult_when_glob = sweph.lun_occult_when_glob;
export const lun_occult_where = sweph.lun_occult_where;
export const lun_eclipse_when_loc = sweph.lun_eclipse_when_loc;
export const lun_eclipse_when = sweph.lun_eclipse_when;
export const lun_eclipse_how = sweph.lun_eclipse_how;
export const rise_trans = sweph.rise_trans;
export const rise_trans_true_hor = sweph.rise_trans_true_hor;
export const pheno = sweph.pheno;
export const pheno_ut = sweph.pheno_ut;
export const azalt = sweph.azalt;
export const azalt_rev = sweph.azalt_rev;
export const refrac = sweph.refrac;
export const refrac_extended = sweph.refrac_extended;
export const heliacal_ut = sweph.heliacal_ut;
export const vis_limit_mag = sweph.vis_limit_mag;
export const heliacal_pheno_ut = sweph.heliacal_pheno_ut;
export const julday = sweph.julday;
export const date_conversion = sweph.date_conversion;
export const revjul = sweph.revjul;
export const utc_time_zone = sweph.utc_time_zone;
export const utc_to_jd = sweph.utc_to_jd;
export const jdet_to_utc = sweph.jdet_to_utc;
export const jdut1_to_utc = sweph.jdut1_to_utc;
export const time_equ = sweph.time_equ;
export const lmt_to_lat = sweph.lmt_to_lat;
export const lat_to_lmt = sweph.lat_to_lmt;
export const deltat = sweph.deltat;
export const deltat_ex = sweph.deltat_ex;
export const house_name = sweph.house_name;
export const houses = sweph.houses;
export const houses_armc = sweph.houses_armc;
export const houses_armc_ex2 = sweph.houses_armc_ex2;
export const houses_ex = sweph.houses_ex;
export const houses_ex2 = sweph.houses_ex2;
export const house_pos = sweph.house_pos;
export const gauquelin_sector = sweph.gauquelin_sector;
export const sidtime = sweph.sidtime;
export const sidtime0 = sweph.sidtime0;
export const cotrans = sweph.cotrans;
export const cotrans_sp = sweph.cotrans_sp;
export const degnorm = sweph.degnorm;
export const radnorm = sweph.radnorm;
export const split_deg = sweph.split_deg;
export const csnorm = sweph.csnorm;
export const difcsn = sweph.difcsn;
export const difdegn = sweph.difdegn;
export const difcs2n = sweph.difcs2n;
export const difdeg2n = sweph.difdeg2n;
export const csroundsec = sweph.csroundsec;
export const d2l = sweph.d2l;
export const day_of_week = sweph.day_of_week;
export const cs2timestr = sweph.cs2timestr;
export const cs2lonlatstr = sweph.cs2lonlatstr;
export const cs2degstr = sweph.cs2degstr;
export const solcross = sweph.solcross;
export const solcross_ut = sweph.solcross_ut;
export const mooncross = sweph.mooncross;
export const mooncross_ut = sweph.mooncross_ut;
export const mooncross_node = sweph.mooncross_node;
export const mooncross_node_ut = sweph.mooncross_node_ut;
export const helio_cross = sweph.helio_cross;
export const helio_cross_ut = sweph.helio_cross_ut;
